#include <ctime>
#include <cstdlib>

#include "video.h"
#include "kello.h"

Kello::Kello(unsigned X,unsigned Y, unsigned XS,unsigned YS)
			:	x(X),y(Y),xs(XS),ys(YS), osa(-1)
{
	if(y<12)y=12;
	if(y+ys>=(unsigned)LINES)ys=LINES-y-1;
	buf = (uc *)malloc(xs*ys*3);
	ca  = (uc *)malloc(xs*ys);
	Clear();
}
void Kello::Clear()
{
	if(ca)memset(ca, 0, xs*ys);
}
Kello::~Kello()
{
	if(buf)free(buf);
	if(ca) free(ca);
}
void Kello::PSet(const unsigned X,const unsigned Y)
{
	if(buf)buf[(X/2)+Y*xs] |= 1 << (X&1);
}
void Kello::Line(const unsigned x1,const unsigned y1,
				 const unsigned x2,const unsigned y2)
{
	unsigned NumPixels, i;
	const unsigned DeltaX = abs((int)x2 - (int)x1);
	const unsigned DeltaY = abs((int)y2 - (int)y1);
	int	d, dinc1, dinc2;
	int x, xinc1, xinc2;
	int y, yinc1, yinc2;
	if(DeltaX >= DeltaY)
	{
		NumPixels = DeltaX + 1;
		d = DeltaY * 2 - DeltaX;
  		 	dinc1 = DeltaY * 2;
		dinc2 = ((int)DeltaY - (int)DeltaX) * 2;
		yinc1 = 0, xinc1 = xinc2 = yinc2 = 1;
	}
	else
	{
		NumPixels = DeltaY + 1;
		d = DeltaX * 2 - DeltaY;
   	 	dinc1 = DeltaX * 2;
		dinc2 = ((int)DeltaX - (int)DeltaY) * 2;
		xinc1 = 0, yinc1 = yinc2 = xinc2 = 1;
	}
	if(x1 > x2) {xinc1 = -xinc1; xinc2 = -xinc2;}
	if(y1 > y2) {yinc1 = -yinc1; yinc2 = -yinc2;}
	
	for(x=x1, y=y1, i=1; i<NumPixels; i++)
	{
		PSet(x, y);
		if(d<0)	d += dinc1, x += xinc1, y += yinc1;
		else	d += dinc2, x += xinc2, y += yinc2;
	}
}
void Kello::Viisari(const float p60, const float d1,const float d2)
{
	register float rad = p60 * (3.141592653 / 30.0);
	Line(unsigned(xs+xs*d1*sin(rad)), unsigned(ys-ys*d1*cos(rad))*3/2,
		 unsigned(xs+xs*d2*sin(rad)), unsigned(ys-ys*d2*cos(rad))*3/2);
}
int Kello::Update()
{
	if(!buf || !ca)return 0;
	time_t t = time(NULL);
	const struct tm *TM = localtime(&t);
	
	float sa = TM->tm_sec;
	
	if(sa == osa)return 0;
	
	osa = sa;
	
	memset(buf, 0, xs*ys*3);
	for(int a=0; a<60; a++)Viisari(a, a%5 ? 0.9 : 0.83, 1);
	
	float ma = TM->tm_min + sa / 60.0;
	float ha = TM->tm_hour*5.0 + ma / 60.0;
	
	Viisari(sa, 0,0.8);
	Viisari(ma, 0,0.7);
	Viisari(ha, 0,0.5);
	
	uc *s = buf;
	uc *e = ca;
	
	video = 0x10;
	
	int mod = 0;
	
	for(unsigned Y=0; Y<ys; Y++, s += xs*2)
		for(unsigned X=0; X<xs; X++, e++, s++)
		{
       		/*  ab                                  */
       		/*  cd                       d          */
       		/*  ef         c      d    ddc          */
       		/*      b    ccb    ddb   dccb          */
       		/*    aba   caba   daba   caba          */
       		static const unsigned char Buf[] =
       			" `~^" "-''^" "-``^" "-`'\""  /*    */
       			".;;=" ",|/F" ",>/?" "r}/P"   /* e  */
       			".::="",\\<t"",\\|7""q\\{9"   /* f  */
       			"_===" "_LJC" ",jJ]" "wbd@";  /* ef */
       			
       		/*	ABCDEFGHIJKLMNOPQRSTUVWXYZ */
       		/*  abcdefghijklmnopqrstuvwxyz */
       		/*   !"#$%&'()*+,-./0123456789 */
       		/*  :;<=>?@[\]^_{|}~           */
       		
       		uc ch = Buf[ s[0] | (s[xs]<<2) | (s[xs*2]<<4) ];
       		
       		if(ch != *e)
       		{
       			video.Goto(y+Y, x+X, 0);
       			video << (*e=ch);
       			mod = 1;
       		}
		}
	video.Flush();
	return mod;
}
